export interface Status {
    value: any;
    obsolete: boolean;
    error: any;
    latency: number;
}
export declare class Vario {
    static statusof(method: F<any>): Status;
    static autorenew(latency: number, method: F<any>, ...args: any[]): void;
    static dispose(obj: object | undefined): void;
}
export declare function tran(target: object, prop?: PropertyKey, pd?: TypedPropertyDescriptor<F<any>>): any;
export declare function cache(ctor: object, prop: PropertyKey, descriptor: TypedPropertyDescriptor<F<any>>): any;
export declare type F<T> = (...args: any[]) => T;
export declare class Transaction {
    private static id;
    readonly id: number;
    readonly hint: string;
    readonly snapshot: number;
    readonly error: any;
    private _snapshot;
    private changeset;
    private pending;
    private sealed;
    private _error;
    private resultPromise;
    private resultResolve;
    private resultReject;
    private conflicts;
    private autorenew;
    constructor(hint?: string);
    static readonly current: Transaction | undefined;
    run<T>(func: F<T>, ...args: any[]): T;
    wrap<T>(func: F<T>): F<T>;
    commit(): void;
    sealToCommit(): Transaction;
    discard(error?: any): Transaction;
    waitForFinish(): Promise<void>;
    finished(): boolean;
    static run<T>(hint: string, func: F<T>, ...args: any[]): T;
    static runAsync<T>(hint: string, func: F<Promise<T>>, ...args: any[]): Promise<T>;
    private _run;
    private sealAndRethrowErrorIfNeeded;
    private static seal;
    private checkConflictsResolved;
    private tryResolveConflicts;
    static _acquireSnapshot(t: Transaction): void;
    static _releaseSnapshot(t: Transaction): void;
    private performCommit;
    private performDiscard;
    private acquirePromise;
    static _changeset(t: Transaction): Map<Handle, Record>;
    static _wrap<T>(t: Transaction, c: Cache | undefined, inc: boolean, dec: boolean, func: F<T>): F<T>;
}
export declare class History {
    private _capacity;
    private _items;
    private _position;
    capacity: number;
    readonly items: ReadonlyArray<Transaction>;
    readonly canUndo: boolean;
    readonly canRedo: boolean;
    remember(t: Transaction): void;
    undo(count: number): boolean;
    redo(count: number): boolean;
}
export declare class StoreParams {
    readonly name?: string;
    readonly idProperty?: string;
    readonly isObjectWithId?: (obj: object) => boolean;
    readonly twoWaySync?: (incomingPatches: object[], outgoingPatches: object[]) => void;
}
export declare class Store {
    readonly params: StoreParams;
    constructor(params?: StoreParams);
    static dispose(obj: object): void;
}
declare class Handle {
    private static id;
    readonly store: Store;
    readonly proxy: any;
    private readonly id;
    private committed;
    private editable;
    private editors;
    constructor(store: Store, proxy: any);
    hint(typeless?: boolean): string;
    getCommitted(): Record;
    getRelevant(t: Transaction, c: Cache | undefined): Record | undefined;
    getForView(): Record;
    getForEdit(prop: PropertyKey, value: any): Record | undefined;
    getForRenew(prop: PropertyKey): Record;
    static applyChanges(commit: boolean, changeset: Map<Handle, Record>): void;
    dispose(): void;
}
declare class Record {
    readonly previous: {
        record: Record | undefined;
        backup: Record | undefined;
    };
    readonly handle: Handle;
    readonly tran: Transaction;
    readonly data: any;
    readonly edits: Set<PropertyKey>;
    readonly conflicts: Map<PropertyKey, Record>;
    readonly observers: Map<PropertyKey, Set<Cache>>;
    readonly obsolete: Set<PropertyKey>;
    constructor(prev: Record | undefined, handle: Handle, tran: Transaction, data: object);
    readonly prev: Record | undefined;
    hint(typeless?: boolean, prop?: PropertyKey): string;
    registerPropEdit(prop: PropertyKey, edited: boolean): void;
    determineConflicts(): boolean;
    static markObsolete(self: Record | undefined, prop: PropertyKey): void;
    acquireObservers(prop: PropertyKey): Set<Cache>;
    retainPrevObservers(prop: PropertyKey, prev: Record, prevObservers: Set<Cache>): Set<Cache>;
    static cleanup(t: Transaction): void;
    freeze(): void;
}
declare class Member {
    readonly isTran: boolean;
    readonly isAsync: boolean;
    readonly name: PropertyKey;
    readonly body: (...args: any[]) => any;
    constructor(isTran: boolean, isAsync: boolean, name: PropertyKey, body: F<any>);
}
declare class Cache {
    readonly record: Record;
    readonly member: Member;
    readonly trap: (...args: any[]) => any;
    readonly observables: Map<PropertyKey, Set<Record>>;
    args: any[];
    value: any;
    obsolete: string | undefined;
    error: any;
    latency: number;
    readonly margin: number;
    constructor(owner: Record, member: Member, latency: number, margin: number);
    readonly hint: string;
    run<T>(func: F<T>, ...args: any[]): T;
    wrap<T>(func: F<T>): F<T>;
    autorenew(now: boolean): void;
    static registerPropView(record: Record, prop: PropertyKey): void;
    static propagateChanges(changeset: Map<Handle, Record>, autorenew: Cache[]): void;
    private linkWithObservables;
    private static markObsolete;
    private createTrap;
    private renew;
    private renewAsync;
}
export {};
