"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var Vario = (function () {
    function Vario() {
    }
    Vario.statusof = function (method) {
        var result = { value: undefined, obsolete: false, error: undefined, latency: -1 };
        var c = Tools.getHandle(method);
        if (c instanceof Cache) {
            Cache.registerPropView(c.record.handle.getForView(), c.member.name);
            result = { value: c.value, obsolete: c.obsolete !== undefined, error: c.error, latency: c.latency };
        }
        return result;
    };
    Vario.autorenew = function (latency, method) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        var c = Tools.getHandle(method);
        if (c instanceof Cache) {
            c.args = args;
            c.latency = latency;
            if (latency >= 0)
                c.autorenew(true);
        }
        else
            throw new Error("only cached method can be renewed automatically");
    };
    Vario.dispose = function (obj) {
        if (obj) {
            var h = Tools.getHandle(obj);
            if (h instanceof Handle)
                h.dispose();
        }
    };
    return Vario;
}());
exports.Vario = Vario;
function tran(target, prop, pd) {
    return prop ? memberDecorator(pd !== undefined, target, prop, pd) : classDecorator(target);
}
exports.tran = tran;
function cache(ctor, prop, descriptor) {
    return memberDecorator(false, ctor, prop, descriptor);
}
exports.cache = cache;
var Transaction = (function () {
    function Transaction(hint) {
        this.id = 0;
        this._snapshot = 0;
        this.changeset = new Map();
        this.pending = 0;
        this.sealed = false;
        this._error = undefined;
        this.resultPromise = undefined;
        this.resultResolve = forbidden;
        this.resultReject = forbidden;
        this.conflicts = undefined;
        this.autorenew = [];
        this.id = ++Transaction.id;
        this.hint = hint || "noname";
    }
    Object.defineProperty(Transaction.prototype, "snapshot", {
        get: function () { return this._snapshot; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Transaction.prototype, "error", {
        get: function () { return this._error; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(Transaction, "current", {
        get: function () { return Ctx.tran; },
        enumerable: true,
        configurable: true
    });
    Transaction.prototype.run = function (func) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        if (this.sealed && Ctx.tran !== this)
            throw new Error("E601: cannot run sealed transaction");
        return this._run.apply(this, [func].concat(args));
    };
    Transaction.prototype.wrap = function (func) {
        return Transaction._wrap(this, Ctx.cache, true, true, func);
    };
    Transaction.prototype.commit = function () {
        if (this.pending > 0)
            throw new Error("E602: cannot commit transaction having pending async operations");
        if (this._error)
            throw new Error("E603: cannot commit discarded transaction: " + this._error);
        this.sealToCommit();
    };
    Transaction.prototype.sealToCommit = function () {
        if (!this.sealed)
            this.run(Transaction.seal, this);
        return this;
    };
    Transaction.prototype.discard = function (error) {
        if (error === void 0) { error = "transaction discarded"; }
        if (!this._error)
            this._error = error;
        if (!this.sealed)
            this.run(Transaction.seal, this);
        return this;
    };
    Transaction.prototype.waitForFinish = function () {
        return this.acquirePromise();
    };
    Transaction.prototype.finished = function () {
        return this.sealed && this.pending === 0;
    };
    Transaction.run = function (hint, func) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        var t = Ctx.tran || new Transaction(hint);
        var result;
        try {
            result = t.run.apply(t, [func].concat(args));
            t.sealAndRethrowErrorIfNeeded();
        }
        catch (error) {
            t.discard(error);
            throw error;
        }
        return result;
    };
    Transaction.runAsync = function (hint, func) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var t, result, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        t = Ctx.tran || new Transaction(hint);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4, t.run.apply(t, [func].concat(args))];
                    case 2:
                        result = _a.sent();
                        t.sealAndRethrowErrorIfNeeded();
                        return [3, 4];
                    case 3:
                        error_1 = _a.sent();
                        t.discard(error_1);
                        throw error_1;
                    case 4: return [2, result];
                }
            });
        });
    };
    Transaction.prototype._run = function (func) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var outer = Ctx.tran;
        var result;
        try {
            this.pending++;
            Ctx.tran = this;
            result = func.apply(void 0, args);
            if (this.sealed && this.pending === 1 && !this._error)
                this.checkConflictsResolved();
        }
        catch (e) {
            this._error = this._error || e;
            throw e;
        }
        finally {
            this.pending--;
            if (this.finished()) {
                !this._error ? this.performCommit() : this.performDiscard();
                Tools.freezeMap(this.changeset);
                Object.freeze(this);
            }
            Ctx.tran = outer;
        }
        if (this.finished())
            for (var _a = 0, _b = this.autorenew; _a < _b.length; _a++) {
                var x = _b[_a];
                x.autorenew(false);
            }
        return result;
    };
    Transaction.prototype.sealAndRethrowErrorIfNeeded = function () {
        if (!Ctx.tran)
            this.sealToCommit();
        if (this.finished() && this._error)
            throw this._error;
    };
    Transaction.seal = function (t) {
        t.sealed = true;
    };
    Transaction.prototype.checkConflictsResolved = function () {
        var _this = this;
        this.conflicts = undefined;
        this.changeset.forEach(function (r, h) {
            if (r.determineConflicts()) {
                if (!_this.conflicts)
                    _this.conflicts = [];
                _this.conflicts.push(r);
            }
        });
        if (this.conflicts)
            this.tryResolveConflicts(this.conflicts);
    };
    Transaction.prototype.tryResolveConflicts = function (conflicts) {
        this._error = this._error || new Error(this.hint + " conflicts with other transactions on: " + Tools.formatConflictsSummary(conflicts));
    };
    Transaction._acquireSnapshot = function (t) {
        if (t._snapshot === 0) {
            t._snapshot = Ctx.snapshot;
            Ctx.running.push(t);
            if (LOG)
                trace(37, "╔═══", "v" + t.snapshot, "" + t.hint);
        }
    };
    Transaction._releaseSnapshot = function (t) {
        if (t._snapshot !== 0) {
            if (Ctx.running[0] === t) {
                var i = 0;
                for (var _i = 0, _a = Ctx.running; _i < _a.length; _i++) {
                    var x = _a[_i];
                    if (x.finished()) {
                        if (!x.error)
                            Record.cleanup(x);
                    }
                    else
                        break;
                    i++;
                }
                Ctx.running = Ctx.running.slice(i);
            }
        }
    };
    Transaction.prototype.performCommit = function () {
        if (this.changeset.size > 0) {
            this._snapshot = ++Ctx.snapshot;
            Handle.applyChanges(true, this.changeset);
            if (LOG)
                trace(37, this.snapshot > 0 ? "╚═══" : "═══", "v" + this.snapshot, this.hint + " - COMMIT(" + this.changeset.size + ")");
            Cache.propagateChanges(this.changeset, this.autorenew);
        }
        else if (LOG)
            trace(37, this.snapshot > 0 ? "╚═══" : "═══", "v" + this.snapshot, this.hint + " - DRY");
        Transaction._releaseSnapshot(this);
        if (this.resultPromise)
            this.resultResolve();
    };
    Transaction.prototype.performDiscard = function () {
        Handle.applyChanges(false, this.changeset);
        if (LOG)
            trace(31, "╚═══", "v" + this.snapshot, this.hint + " - DISCARD(" + this.changeset.size + ") - " + this._error);
        Transaction._releaseSnapshot(this);
        if (this.resultPromise)
            this.resultReject(this._error);
    };
    Transaction.prototype.acquirePromise = function () {
        var _this = this;
        if (!this.resultPromise) {
            this.resultPromise = new Promise(function (resolve, reject) {
                _this.resultResolve = resolve;
                _this.resultReject = reject;
            });
        }
        return this.resultPromise;
    };
    Transaction._changeset = function (t) {
        return t.changeset;
    };
    Transaction._wrap = function (t, c, inc, dec, func) {
        var f = c ? c.wrap(func) : func;
        if (inc)
            t.run(function () { return t.pending++; });
        var tran = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return t._run(function () {
                if (dec)
                    t.pending--;
                return f.apply(void 0, args);
            });
        };
        return tran;
    };
    Transaction.id = 9;
    return Transaction;
}());
exports.Transaction = Transaction;
var History = (function () {
    function History() {
        this._capacity = 5;
        this._items = [];
        this._position = 0;
    }
    Object.defineProperty(History.prototype, "capacity", {
        get: function () { return this._capacity; },
        set: function (value) { this._capacity = value; if (value < this._items.length)
            this._items.splice(0, this._items.length - value); },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(History.prototype, "items", {
        get: function () { return this._items; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(History.prototype, "canUndo", {
        get: function () { return this._items.length > 0 && this._position > 0; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(History.prototype, "canRedo", {
        get: function () { return this._position < this._items.length; },
        enumerable: true,
        configurable: true
    });
    History.prototype.remember = function (t) {
        if (this._items.length >= this._capacity)
            this._items.shift();
        else
            this._items.splice(this._position);
        this._items.push(t);
    };
    History.prototype.undo = function (count) {
        throw new Error("not implemented");
    };
    History.prototype.redo = function (count) {
        throw new Error("not implemented");
    };
    return History;
}());
exports.History = History;
var StoreParams = (function () {
    function StoreParams() {
    }
    return StoreParams;
}());
exports.StoreParams = StoreParams;
var Store = (function () {
    function Store(params) {
        this.params = params || {};
    }
    Store.dispose = function (obj) {
    };
    return Store;
}());
exports.Store = Store;
var VARIO = Symbol("vario");
var VARIO_META = Symbol("meta");
var VARIO_DTOR = Symbol("dtor");
function forbidden() {
    var args = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
    }
    throw new Error("operation is forbidden");
}
var Ctx = (function () {
    function Ctx() {
    }
    Ctx.snapshot = 10;
    Ctx.tran = undefined;
    Ctx.cache = undefined;
    Ctx.store = new Store({ name: "vario" });
    Ctx.zerotran = new Transaction("notran");
    Ctx.running = [];
    Ctx.history = [];
    Ctx.historyCapacity = 5;
    return Ctx;
}());
var Handle = (function () {
    function Handle(store, proxy) {
        var _this = this;
        this.editable = undefined;
        this.editors = 0;
        var data = {};
        this.store = store;
        this.proxy = proxy;
        this.id = ++Handle.id;
        this.committed = new Record(undefined, this, Ctx.zerotran, data);
        var meta = proxy[VARIO_META] || new Map();
        meta.forEach(function (member, prop) {
            if (member.body !== undefined) {
                data[prop] = new Cache(_this.committed, member, -1, 0);
                Record.markObsolete(_this.committed, prop);
            }
        });
        this.committed.freeze();
    }
    Handle.prototype.hint = function (typeless) { return (!typeless ? this.proxy.constructor.name : "") + "#" + this.id; };
    Handle.prototype.getCommitted = function () {
        return this.committed;
    };
    Handle.prototype.getRelevant = function (t, c) {
        Transaction._acquireSnapshot(t);
        var result = this.editable;
        if (result && result.tran !== t) {
            result = Transaction._changeset(t).get(this);
            if (result)
                this.editable = result;
        }
        if (!result) {
            result = this.committed;
            while (result && result.tran.snapshot > t.snapshot)
                result = result.prev;
        }
        return result;
    };
    Handle.prototype.getForView = function () {
        var t = Ctx.tran;
        var result = t ? this.getRelevant(t, Ctx.cache) : this.committed;
        if (!result)
            throw new Error("E607: internal error");
        return result;
    };
    Handle.prototype.getForEdit = function (prop, value) {
        var c = Ctx.cache;
        if (c && !c.member.isTran && c.record.handle !== this && value !== VARIO)
            throw new Error("E608: object cannot be changed outside of cache function");
        var t = Ctx.tran;
        if (!t)
            throw new Error("E609: object cannot be changed outside of transaction");
        var r = this.getRelevant(t, c);
        if (!r || !Tools.equal(r.data[prop], value)) {
            var data = r ? r.data : value;
            if (!r || r.tran !== t) {
                data = __assign({}, data);
                r = new Record(this.committed, this, t, data);
                Transaction._changeset(t).set(this, r);
                this.editable = r;
                this.editors++;
            }
            var v = r.prev ? r.prev.data[prop] : undefined;
            r.registerPropEdit(prop, !Tools.equal(v, value) && value !== VARIO);
        }
        else
            r = undefined;
        return r;
    };
    Handle.prototype.getForRenew = function (prop) {
        var result = this.getForEdit(prop, VARIO);
        if (!result)
            throw new Error("unknown error");
        return result;
    };
    Handle.applyChanges = function (commit, changeset) {
        changeset.forEach(function (r, h) {
            r.freeze();
            h.editors--;
            if (h.editors === 0)
                h.editable = undefined;
            if (commit)
                h.committed = r;
            if (LOG) {
                var props_1 = [];
                r.edits.forEach(function (prop) { return props_1.push(prop.toString()); });
                trace(32, "║", "M", r.hint() + ": " + props_1.join(", "));
            }
        });
    };
    Handle.prototype.dispose = function () {
        var _this = this;
        Transaction.run(this.hint() + ".dtor", function () { return _this.getForEdit(VARIO_DTOR, VARIO_DTOR); });
    };
    Handle.id = 10;
    return Handle;
}());
var Record = (function () {
    function Record(prev, handle, tran, data) {
        this.previous = { record: prev, backup: undefined };
        this.handle = handle;
        this.tran = tran;
        this.data = data;
        this.edits = new Set();
        this.conflicts = new Map();
        this.observers = new Map();
        this.obsolete = new Set();
    }
    Object.defineProperty(Record.prototype, "prev", {
        get: function () { return this.previous ? this.previous.record : undefined; },
        enumerable: true,
        configurable: true
    });
    Record.prototype.hint = function (typeless, prop) {
        return prop !== undefined ?
            this.handle.hint(typeless) + "t" + this.tran.id + "." + prop.toString() :
            this.handle.hint(typeless) + "t" + this.tran.id;
    };
    Record.prototype.registerPropEdit = function (prop, edited) {
        edited ? this.edits.add(prop) : this.edits.delete(prop);
    };
    Record.prototype.determineConflicts = function () {
        var _this = this;
        var committed = this.handle.getCommitted();
        if (committed.tran.snapshot > this.tran.snapshot) {
            var dtor_1 = committed.edits.has(VARIO_DTOR);
            this.edits.forEach(function (prop) {
                var theirs = committed;
                while (theirs && theirs.tran.snapshot > _this.tran.snapshot) {
                    if (theirs.edits.has(prop)) {
                        if (!Tools.equal(theirs.data[prop], _this.data[prop]))
                            _this.conflicts.set(prop, theirs);
                        theirs = _this;
                    }
                    else if (prop === VARIO_DTOR || dtor_1) {
                        _this.conflicts.set(prop, theirs);
                        theirs = _this;
                    }
                    else
                        theirs = theirs.prev;
                }
            });
        }
        return this.conflicts.size > 0;
    };
    Record.markObsolete = function (self, prop) {
        while (self && !self.obsolete.has(prop)) {
            self.obsolete.add(prop);
            Tools.freezeSet(self.observers.get(prop));
            self = self.prev;
        }
    };
    Record.prototype.acquireObservers = function (prop) {
        var result = this.observers.get(prop);
        if (!result) {
            this.observers.set(prop, result = new Set());
            if (TRACE)
                trace(36, "", "   [ Observers:", this.hint(false, prop) + " = new ]");
            var r = this.prev;
            while (r && !r.observers.get(prop) && r.data[prop] === this.data[prop]) {
                r.observers.set(prop, result);
                if (TRACE)
                    trace(36, "", "   [ Observers:", r.hint(false, prop) + " = " + this.hint(false, prop) + " ]");
                r = r.prev;
            }
        }
        return result;
    };
    Record.prototype.retainPrevObservers = function (prop, prev, prevObservers) {
        var thisObservers = this.observers.get(prop);
        if (thisObservers) {
            thisObservers.forEach(function (c) { return prevObservers.add(c); });
            if (TRACE)
                trace(36, "", " [ Observers:", prev.hint(false, prop) + "(" + prevObservers.size + ") += " + this.hint(false, prop) + "(" + thisObservers.size + ") ]");
        }
        this.observers.set(prop, prevObservers);
        if (TRACE)
            trace(36, "", " [ Observers:", this.hint(false, prop) + " = " + prev.hint(false, prop) + "(" + prevObservers.size + ") ]");
        return prevObservers;
    };
    Record.cleanup = function (t) {
        if (LOG)
            trace(36, "", "gc", "t" + t.id + " (" + t.hint + ")");
        Transaction._changeset(t).forEach(function (r, h) {
            if (LOG && r.prev)
                trace(36, "", "gc", r.prev.hint() + " is ready for GC (overwritten by " + r.hint() + "}");
            r.previous.record = undefined;
        });
    };
    Record.prototype.freeze = function () {
        var _this = this;
        Object.freeze(this.data);
        this.edits.forEach(function (prop) {
            var val = _this.data[prop];
            if (Array.isArray(val) && !Object.isFrozen(val))
                Tools.freezeArray(val, { object: _this.handle.proxy, property: prop });
        });
        Tools.freezeSet(this.edits);
        Tools.freezeMap(this.conflicts);
        Object.freeze(this);
    };
    return Record;
}());
var Member = (function () {
    function Member(isTran, isAsync, name, body) {
        this.isTran = isTran;
        this.isAsync = isAsync;
        this.name = name;
        this.body = body;
        Object.freeze(this);
    }
    return Member;
}());
var Cache = (function () {
    function Cache(owner, member, latency, margin) {
        this.record = owner;
        this.member = member;
        this.trap = this.createTrap();
        this.observables = new Map();
        this.args = [];
        this.value = undefined;
        this.obsolete = this.hint;
        this.error = undefined;
        this.latency = latency;
        this.margin = margin;
    }
    Object.defineProperty(Cache.prototype, "hint", {
        get: function () { return this.record.handle.hint() + "t" + this.record.tran.id + "." + this.member.name.toString(); },
        enumerable: true,
        configurable: true
    });
    Cache.prototype.run = function (func) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        var outer = Ctx.cache;
        try {
            Ctx.cache = this;
            return func.apply(void 0, args);
        }
        catch (e) {
            this.error = e;
            throw e;
        }
        finally {
            Ctx.cache = outer;
        }
    };
    Cache.prototype.wrap = function (func) {
        var _this = this;
        var caching = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return _this.run.apply(_this, [func].concat(args));
        };
        return caching;
    };
    Cache.prototype.autorenew = function (now) {
        var _this = this;
        if (now || this.latency === 0) {
            if ((this.obsolete || this.member.isTran) && !this.error)
                if (this.member.isAsync)
                    this.trap.apply(this, this.args).catch(function (error) { });
                else
                    this.trap.apply(this, this.args);
        }
        else
            setTimeout(function () { return _this.autorenew(true); }, this.latency);
    };
    Cache.registerPropView = function (record, prop) {
        var cache = Ctx.cache;
        if (cache && !cache.member.isTran) {
            var observables = cache.observables.get(prop);
            if (!observables)
                cache.observables.set(prop, observables = new Set());
            observables.add(record);
        }
    };
    Cache.propagateChanges = function (changeset, autorenew) {
        changeset.forEach(function (r, h) {
            var dtor = r.edits.has(VARIO_DTOR);
            if (r.prev) {
                var prev_1 = r.prev;
                prev_1.observers.forEach(function (prevObservers, prop) {
                    if (dtor || r.edits.has(prop))
                        prevObservers.forEach(function (c) { return Cache.markObsolete(c, r.hint(false, prop), autorenew); });
                    else
                        r.retainPrevObservers(prop, prev_1, prevObservers);
                });
            }
            r.edits.forEach(function (prop) {
                Record.markObsolete(r.prev, prop);
                var c = r.data[prop];
                if (c instanceof Cache) {
                    var cause = c.linkWithObservables();
                    if (cause)
                        Cache.markObsolete(c, cause, autorenew);
                }
            });
        });
    };
    Cache.prototype.linkWithObservables = function () {
        var _this = this;
        var obsolete = undefined;
        var log = [];
        this.observables.forEach(function (observables, prop) {
            observables.forEach(function (r) {
                r.acquireObservers(prop).add(_this);
                if (LOG)
                    log.push(r.hint(true, prop));
                if (!obsolete && r.obsolete.has(prop))
                    obsolete = r.hint(false, prop);
            });
        });
        if (LOG)
            trace(34, "", " ∞", this.record.hint(false, this.member.name) + ": " + log.join(", "));
        return obsolete;
    };
    Cache.markObsolete = function (cache, cause, autorenew) {
        if (!cache.obsolete) {
            cache.obsolete = cause;
            Record.markObsolete(cache.record, cache.member.name);
            Tools.freezeMap(cache.observables);
            if (LOG)
                trace(36, "", " x", cache.hint + " is obsolete (by " + cause + ")");
            if (cache.latency >= 0) {
                autorenew.push(cache);
                if (LOG)
                    trace(36, "", " ■", cache.hint + " will be renewed automatically");
            }
            var observers = cache.record.observers.get(cache.member.name);
            if (observers)
                observers.forEach(function (c) { return Cache.markObsolete(c, cache.record.hint(false, cache.member.name), autorenew); });
        }
    };
    Cache.prototype.createTrap = function () {
        var _this = this;
        var self = this;
        var trap;
        if (this.member.isAsync)
            trap = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return __awaiter(_this, void 0, void 0, function () {
                    var c;
                    var _this = this;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                c = self;
                                if (!(c.member.isTran || c.obsolete)) return [3, 2];
                                return [4, Transaction.runAsync.apply(Transaction, [c.hint, function () {
                                            var argsx = [];
                                            for (var _i = 0; _i < arguments.length; _i++) {
                                                argsx[_i] = arguments[_i];
                                            }
                                            return __awaiter(_this, void 0, void 0, function () {
                                                return __generator(this, function (_a) {
                                                    return [2, c.renewAsync.apply(c, argsx)];
                                                });
                                            });
                                        }].concat(args))];
                            case 1:
                                c = _a.sent();
                                _a.label = 2;
                            case 2:
                                Cache.registerPropView(c.record, c.member.name);
                                return [2, c.value];
                        }
                    });
                });
            };
        else
            trap = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                var c = self;
                if (c.member.isTran || c.obsolete) {
                    c = Transaction.run.apply(Transaction, [c.hint, function () {
                            var argsx = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                argsx[_i] = arguments[_i];
                            }
                            return c.renew.apply(c, argsx);
                        }].concat(args));
                }
                Cache.registerPropView(c.record, c.member.name);
                return c.value;
            };
        Tools.setHandle(trap, this);
        return trap;
    };
    Cache.prototype.renew = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        var prop = this.member.name;
        var r = this.record.handle.getForRenew(prop);
        var c = r.data[prop];
        if (c.member.isTran || c.obsolete) {
            var c2_1 = r.data[prop] = new Cache(r, c.member, c.latency, Ctx.cache ? Ctx.cache.margin + 1 : 0);
            c2_1.args = args;
            c2_1.obsolete = undefined;
            c2_1.value = c2_1.run.apply(c2_1, [function () {
                    var argsx = [];
                    for (var _i = 0; _i < arguments.length; _i++) {
                        argsx[_i] = arguments[_i];
                    }
                    var _a;
                    if (TRACE)
                        trace(34, "║", "┌──", "" + c2_1.hint);
                    var result = (_a = c2_1.member.body).call.apply(_a, [c2_1.record.handle.proxy].concat(argsx));
                    if (TRACE)
                        trace(34, "║", "└──", "" + c2_1.hint);
                    return result;
                }].concat(args));
            if (!c2_1.member.isTran)
                r.registerPropEdit(prop, true);
            c = c2_1;
        }
        if (c.error)
            throw c.error;
        return c;
    };
    Cache.prototype.renewAsync = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var prop, r, c, c2_2, _a;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        prop = this.member.name;
                        r = this.record.handle.getForRenew(prop);
                        c = r.data[prop];
                        if (!(c.member.isTran || c.obsolete)) return [3, 2];
                        c2_2 = r.data[c.member.name] = new Cache(r, c.member, c.latency, Ctx.cache ? Ctx.cache.margin + 1 : 0);
                        c2_2.args = args;
                        c2_2.obsolete = undefined;
                        _a = c2_2;
                        return [4, c2_2.run.apply(c2_2, [function () {
                                    var argsx = [];
                                    for (var _i = 0; _i < arguments.length; _i++) {
                                        argsx[_i] = arguments[_i];
                                    }
                                    return __awaiter(_this, void 0, void 0, function () {
                                        var _a, result;
                                        return __generator(this, function (_b) {
                                            switch (_b.label) {
                                                case 0:
                                                    if (TRACE)
                                                        trace(34, "║", "┌──", "" + c2_2.hint);
                                                    return [4, (_a = c2_2.member.body).call.apply(_a, [c2_2.record.handle.proxy].concat(argsx))];
                                                case 1:
                                                    result = _b.sent();
                                                    if (TRACE)
                                                        trace(34, "║", "└──", "" + c2_2.hint);
                                                    return [2, result];
                                            }
                                        });
                                    });
                                }].concat(args))];
                    case 1:
                        _a.value = _b.sent();
                        if (!c2_2.member.isTran)
                            r.registerPropEdit(prop, true);
                        c = c2_2;
                        _b.label = 2;
                    case 2:
                        if (c.error)
                            throw c.error;
                        return [2, c];
                }
            });
        });
    };
    return Cache;
}());
var Tools = (function () {
    function Tools() {
    }
    Tools.getHandle = function (obj) {
        return obj[VARIO];
    };
    Tools.setHandle = function (obj, handle) {
        Object.defineProperty(obj, VARIO, { value: handle, configurable: false, enumerable: false });
        return handle;
    };
    Tools.acquireHandle = function (obj, store) {
        if (obj !== Object(obj) || Array.isArray(obj))
            throw new Error("E604: only objects can be registered in vario store");
        var h = Tools.getHandle(obj);
        if (!h) {
            if (Ctx.tran)
                Transaction._acquireSnapshot(Ctx.tran);
            h = Tools.setHandle(obj, new Handle(store, obj));
        }
        return h;
    };
    Tools.hookArrayItem = function (array, index) {
        var t = array[index];
        var getter = function () { return t; };
        var setter = function (value) {
            var a = array;
            if (Object.isFrozen(a)) {
                var hp = Tools.getHandle(a);
                a = a.slice();
                hp.object[hp.property] = a;
            }
            a[index] = value;
        };
        var pd = Object.getOwnPropertyDescriptor(array, index);
        Object.defineProperty(array, index, { configurable: true, enumerable: pd ? pd.enumerable : true, get: getter, set: setter });
    };
    Tools.hookArrayMethod = function (array, method) {
        array[method.name] = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            var a = array;
            if (Object.isFrozen(a)) {
                var hp = Tools.getHandle(a);
                a = a.slice();
                hp.object[hp.property] = a;
            }
            return method.call.apply(method, [a].concat(args));
        };
    };
    Tools.freezeArray = function (arr, hp) {
        if (Tools.getHandle(arr))
            throw new Error("E610: array cannot be referenced from multiple objects");
        Tools.setHandle(arr, hp);
        for (var item in arr)
            Tools.hookArrayItem(arr, item);
        for (var _i = 0, _a = [arr.push, arr.pop, arr.shift, arr.sort, arr.splice, arr.unshift]; _i < _a.length; _i++) {
            var method = _a[_i];
            Tools.hookArrayMethod(arr, method);
        }
        Object.freeze(arr);
    };
    Tools.freezeSet = function (obj) {
        if (obj instanceof Set) {
            Object.freeze(obj);
        }
    };
    Tools.freezeMap = function (obj) {
        if (obj instanceof Map) {
            obj.set = obj.delete = obj.clear = forbidden;
            Object.freeze(obj);
        }
    };
    Tools.equal = function (oldValue, newValue) {
        var result;
        if (oldValue instanceof Cache) {
            if (newValue instanceof Cache)
                result = oldValue.value === newValue.value;
            else if (newValue instanceof Function)
                result = oldValue.member.body === newValue;
            else
                result = false;
        }
        else
            result = newValue === oldValue;
        return result;
    };
    Tools.formatConflictsSummary = function (conflicts) {
        return conflicts.map(function (ours) {
            var items = [];
            ours.conflicts.forEach(function (theirs, prop) {
                items.push(Tools.formatConflictingProperty(prop, ours, theirs));
            });
            return items.join(", ");
        }).join(", ");
    };
    Tools.formatConflictingProperty = function (prop, ours, theirs) {
        return theirs.hint(false, prop);
    };
    Tools.isAsync = function (func) {
        var string = func.toString().trim();
        return !!(string.match(/^async /) ||
            string.match(/return _ref[^\.]*\.apply/) ||
            string.match(/return __awaiter/));
    };
    Tools.rethrowError = function (error) {
        throw error;
    };
    return Tools;
}());
var LOG = true;
var TRACE = false;
function trace(color, ctx, op, message) {
    var t = Transaction.current;
    color = 31 + (t ? t.id : 0) % 6;
    ctx = t ? "t" + t.id + " " + ctx : "v" + Ctx.snapshot + " " + ctx;
    var margin = "│ ".repeat(Ctx.cache ? Ctx.cache.margin : 0);
    console.log("\x1b[37m%s\x1b[0m \x1b[" + color + "m%s\x1b[0m \x1b[" + color + "m%s%s\x1b[0m \x1b[" + color + "m%s\x1b[0m", "#vario", ctx, margin, op, message);
}
var originalThen = Promise.prototype.then;
Promise.prototype.then = function (onsuccess, onfailure) {
    var t = Ctx.tran;
    if (t) {
        if (onsuccess) {
            onsuccess = Transaction._wrap(t, Ctx.cache, true, true, onsuccess);
            onfailure = Transaction._wrap(t, Ctx.cache, false, true, onfailure || Tools.rethrowError);
        }
        else if (onfailure)
            onfailure = Transaction._wrap(t, Ctx.cache, false, false, onfailure);
    }
    return originalThen.call(this, onsuccess, onfailure);
};
function classDecorator(target) {
    var origCtor = target;
    var newCtor = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        return Transaction.run.apply(Transaction, [origCtor.name + ".ctor", function () {
                var argsx = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    argsx[_i] = arguments[_i];
                }
                var ctor = function () { return origCtor.call.apply(origCtor, [this].concat(argsx)); };
                ctor.prototype = origCtor.prototype;
                return new ctor();
            }].concat(args));
    };
    newCtor.prototype = origCtor.prototype;
    return newCtor;
}
function memberDecorator(isTran, proto, prop, pd) {
    var getter = function () {
        var h = Tools.acquireHandle(this, Ctx.store);
        var r = h.getForView();
        var value = r.data[prop];
        value instanceof Cache ? value = value.trap : Cache.registerPropView(r, prop);
        return value;
    };
    var setter = function (value) {
        var h = Tools.acquireHandle(this, Ctx.store);
        var r = h.getForEdit(prop, value);
        if (r)
            r.data[prop] = value;
    };
    if (pd && pd.value) {
        var meta = proto[VARIO_META] || (proto[VARIO_META] = new Map());
        if (!proto.hasOwnProperty(VARIO_META))
            meta = proto[VARIO_META] = new Map(meta.entries());
        meta.set(prop, new Member(isTran, Tools.isAsync(pd.value), prop, pd.value));
    }
    if (!pd)
        pd = Object.getOwnPropertyDescriptor(proto, prop);
    pd = { configurable: false, enumerable: pd ? pd.enumerable : true, get: getter, set: setter };
    return Object.defineProperty(proto, prop, pd);
}
Ctx.zerotran.commit();
//# sourceMappingURL=vario.js.map